ffac           :: Integral a => a -> a
ffac 0         = 1
ffac n | n > 0 = n * ffac (n-1)

-- ffac 100

afac             :: Integral a => a -> a -> a
afac 0 f         = f
afac n f | n > 0 = afac (n-1) (n*f)

-- afac 100 1

kfac'             :: Integral a => a -> (a -> a) -> a
kfac' 0 k         = k 1
kfac' n k | n > 0 = kfac' (n-1) (\v -> k(n*v))

kfac             :: Integral a => a -> (a -> a) -> a
kfac 0 k         = k 1
kfac n k | n > 0 = kfac (n-1) (k . (n*))

-- kfac 100 id

ffib   :: Integral a => a -> a
ffib 0 = 1
ffib 1 = 1
ffib n = ffib (n-1) + ffib (n-2)

-- ffib 25

afib       :: Integral a => a -> a -> a -> a
afib 1 _ b = b
afib n a b = afib (n-1) b (a+b)

-- afib 25 0 1

kfib     :: Integral a => a -> ((a,a) -> a) -> a
kfib 1 k = k (1,1)
kfib n k = kfib (n-1) $ \(a,b) -> k (b,a+b)

kfib'     :: Integral a => a -> ((a,a) -> a) -> a
kfib' 1 k = k (1,1)
kfib' n k = kfib' (n-1) (\(a,b) -> k (b,a+b))

-- kfib 25 fst

-- negpoz ls = az `ls' szmlista rszben rendezett vltozata, amelyben a
-- negatv szmok ell, a pozitv szmok htul llnak, az eredeti
-- sorrendjk megrzsvel.

-- list comprehension + append
negpoz1 :: (Num a, Ord a) => [a] -> [a]
negpoz1 ls = [ n | n <- ls, n < 0 ] ++
             [ 0 | 0 <- ls ] ++
             [ p | p <- ls, p > 0 ]

-- negpoz1 [0,1,-1,2,-2,0,3,-3,4,0,-4,5,-5]

-- continuation passing style - avoiding append with a trick very much like
-- difference lists in Prolog

negpoz2 :: (Num a, Ord a) => [a] -> [a]
negpoz2 ls = nzp
      where
         (nzp,zp,p) = np ls $ \nzp0 zp0 p0 -> (nzp0,zp0,p0)
         np [] k = k zp p []
         np (x:xs) k | x  < 0 = np xs $ \nzp0 zp0 p0 -> k (x:nzp0) zp0 p0
                     | x == 0 = np xs $ \nzp0 zp0 p0 -> k nzp0 (0:zp0) p0
                     | x  > 0 = np xs $ \nzp0 zp0 p0 -> k nzp0 zp0 (x:p0)

-- negpoz2 [0,1,-1,2,-2,3,-3,4,-4,5,-5]
